# $Id: MIMEType.pm,v 1.1.1.1 2006/12/17 09:35:21 koba Exp $
#	Copyright(c) 2006 Satoshi Kobayashi, All rights reserved.

package XiuMai::MIMEType;

use strict;
use vars qw($VERSION);

$VERSION = do { my @r = (q$Revision: 1.1.1.1 $ =~ /\d+/g);
				sprintf("%d." . "%02d" x $#r, @r) };

sub mime_type {
	my ($file) = @_;

	my ($ext) = $file =~ /\.(\w+)$/;
	! defined $ext				and return 'text/x-xiumai';

	$ext =~ /^txt|text$/i		and return 'text/plain';
	$ext =~ /^htm|html$/i		and return 'text/html';
	$ext =~ /^css$/i			and return 'text/css';
	$ext =~ /^plist$/i			and return 'text/xml';
	$ext =~ /^rtf$/i			and return 'text/rtf';
	$ext =~ /^wiki$/i			and return 'text/x-xiumai';

	$ext =~ /^png$/i			and return 'image/png';
	$ext =~ /^gif$/i			and return 'image/gif';
	$ext =~ /^jpg|jpeg$/i		and return 'image/jpeg';
	$ext =~ /^tif|tiff$/i		and return 'image/tiff';
	$ext =~ /^pic|pict$/i		and return 'image/pict';
	$ext =~ /^bmp$/i			and return 'image/bmp';
	$ext =~ /^ico$/i			and return 'image/x-icon';

	$ext =~ /^mp2|mp3$/i		and return 'audio/mpeg';
	$ext =~ /^aif|aiff$/i		and return 'audio/x-aiff';
	$ext =~ /^wav$/i			and return 'audio/x-wav';

	$ext =~ /^mpg|mpeg$/i		and return 'video/mpeg';
	$ext =~ /^mov|qt$/i			and return 'video/quicktime';

	$ext =~ /^xls$/i			and return 'application/vnd.ms-excel';
	$ext =~ /^ppt$/i			and return 'application/vnd.ms-powerpoint';
	$ext =~ /^doc$/i			and return 'application/msword';
	$ext =~ /^pdf$/i			and return 'application/pdf';

	$ext =~ /^rdf$/i			and return 'application/rdf+xml';

	return 'application/octet-stream';
}

1;
