# $Id: Text.pm,v 1.5 2006/12/20 14:19:55 koba Exp $
#	Copyright(c) 2006 Satoshi Kobayashi, All rights reserved.

package XiuMai::Resource::Text;

use strict;
use XiuMai::Resource;
use XiuMai::XHTML::Text;
use XiuMai::Util qw(cdata);
use FileHandle;
use vars qw($VERSION @ISA);

$VERSION = $XiuMai::VERSION;

@ISA = qw(XiuMai::Resource);

sub new {
	my $class = shift;
	my ($self) = @_;
	return bless $self, $class;
}

sub text {
	my $self = shift;
	return $self->{text};
}

sub _open {
	my $self = shift;
	my $fh = new FileHandle($self->{path})	or return;
	$self->{text} = '';
	while (<$fh>) {
		$self->{text} .= $_;
	}
	return $self;
}

sub _edit {
	my $self = shift;

	my $url = cdata($self->url);

	my $html = new XiuMai::XHTML::Text($self);
	$self->{html}
		= $html->title($self->filename)
			   ->as_string(
					qq(<h1><a href="$url">).cdata($html->title).qq(</a></h1>\n),
					$html->url_navi,
					$html->text_form,
				);

	$self->{type}  = undef;
	$self->{size}  = length($self->{html});
	$self->{mtime} = undef;
	$self->{lang}  = [$html->content_language];

	return $self;
}

sub update {
	my $self = shift;

	return if (! $self->w_ok);

	my $text = $self->{Request}->param('text');

	$self->{redirect_code} = 303;
	$self->{redirect_url}  = './';

	if (! defined $text || ! length $text) {
		unlink($self->{path})	or return;
		return $self;
	}

	my $fh = new FileHandle(">$self->{path}")	or return;
	print $fh $text;
	$fh->close;
	return $self;
}

1;
