# $Id: SetUp.pm,v 1.2 2006/12/24 16:23:12 koba Exp $
#	Copyright(c) 2006 Satoshi Kobayashi, All rights reserved.

package XiuMai::SetUp;

use strict;
use XiuMai;
use FileHandle;
use vars qw($VERSION);

$VERSION = $XiuMai::VERSION;

my $init;

sub _get_version {
	my $filename = "$XiuMai::HOME/VERSION";
	my $fh = new FileHandle($filename)	or return 0;
	chomp(my $version = <$fh>);
	close($fh);
	return $version;
}

sub _set_version {
	my $filename = "$XiuMai::HOME/VERSION";
	my $fh = new FileHandle(">$filename")	or die "$filename: $!\n";
	print $fh "$XiuMai::VERSION\n";
	close($fh);
}

sub _init_dir {
	my ($dirname) = @_;
	return if (-d $dirname);
	mkdir($dirname, 0755)	or die "mkdir $dirname: $!\n";
	warn "Create $dirname/\n";
}

sub _init_file {
	my ($filename) = @_;
	return if (-f $filename);
	my $fh = new FileHandle(">$filename")	or die "$filename: $!\n";
	close($fh);
	warn "Create $filename\n";
}

sub init {
	return if $init;
	my $version = _get_version;
	return $init = $version	if ($XiuMai::VERSION <= $version);

	warn "CURRENT VERSION: $version\n";

	_init_dir ($XiuMai::HOME);
	_init_dir ("$XiuMai::HOME/data");
	_init_dir ("$XiuMai::HOME/auth");
	_init_dir ("$XiuMai::HOME/auth/local");
	_init_dir ("$XiuMai::HOME/auth/cookie");
	_init_file("$XiuMai::HOME/auth/local/passwd");
	_set_version;
	$init = _get_version;

	warn "SetUp VERSION: $init\n";
}

1;
